#include "list.h"
#include "list.c"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct student {
	char *name;
	struct list_elem elem;
};


void insert (struct list *student_list) {
	char *input=malloc(sizeof(char)*20);
  printf("Insert student ID you want to insert: ");
  scanf("%s", input);
  printf("You entered: %s\n", input);

  struct student *new_student = (struct student*) malloc(sizeof(struct student));

  new_student->name = input;

	list_push_back(student_list, &new_student->elem);
	free(input);

};

void delete (struct list *student_list) {
  char *input=malloc(sizeof(char)*20);
	struct list_elem *e;
  printf("Insert student ID you want to delete: ");
  scanf("%s", input);
  printf("You entered: %s\n", input);

	for (e = list_begin (student_list); e != list_end (student_list); e = list_next (e))
		{
			struct student *s = list_entry(e, struct student, elem);

			if (strcmp(s->name, input) == 0) {
				e = list_remove(e);
				free(s);
				break;
			}

		}
		free(input);
};

void list (struct list *student_list) {
	struct list_elem *e2;
	for (e2 = list_begin (student_list); e2 != list_end (student_list); e2 = list_next (e2))
		{
			struct student *st = list_entry(e2, struct student, elem);
			printf("%s\n", st->name);
		
		}

};

void quit (struct list *student_list) {
	while (!list_empty (student_list))
		{
			struct list_elem *e3 = list_pop_front (student_list);
			struct student *stu = list_entry(e3, struct student, elem);
			free(stu);
		}


};

int main() {
	struct list student_list;
	list_init (&student_list);
	int opt;

	do {
		printf("Menu:\n");
		printf("1 - Insert student\n");
		printf("2 - Delete student\n");
		printf("3 - List students\n");
		printf("4 - Exit\n");
		scanf("%d", &opt);
		switch (opt) {
			case 1:
				{
					insert(&student_list);
					break;
				}
			case 2:
				{
					delete(&student_list);
					break;
				}
			case 3:
				{
					list(&student_list);
					break;
				}

			case 4:
				{
					quit(&student_list);
					break;
				}
			default:
				{
					printf("Quit? (1/0):\n");
					scanf("%d", &opt);
					if (opt)
						quit(&student_list);
					break;
				}
		}
	} while(1);

	return 0;
}
